<?php
/*-------------------------------------------------------------------------
# com_improved_ajax_login - Improved_AJAX_Login
# -------------------------------------------------------------------------
# @ author    Balint Polgarfi
# @ copyright Copyright (C) 2013 Offlajn.com  All Rights Reserved.
# @ license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# @ website   http://www.offlajn.com
-------------------------------------------------------------------------*/
?><?php
defined('_JEXEC') or die('Restricted access');

class com_improved_ajax_login extends JObject {

	var $name = 'Improved AJAX Login';

	function install() {
    $db =& JFactory::getDBO();

    if (version_compare(JVERSION,'1.6.0','lt'))
      $db->setQuery("UPDATE #__plugins  SET published=1 WHERE element LIKE 'improved_ajax_login'");
		else
      $db->setQuery("UPDATE #__extensions SET enabled=1 WHERE element LIKE 'improved_ajax_login' AND type='plugin'");
    $db->query();

    $db->setQuery("CREATE TABLE IF NOT EXISTS #__offlajn_users(
      user_id INT(11) NOT NULL, PRIMARY KEY(user_id),
      facebook_id VARCHAR(255) NULL,
      google_id VARCHAR(255) NULL,
      windows_id VARCHAR(255) NULL,
      twitter_id VARCHAR(255) NULL
    )");
    $db->query();
    $db->setQuery("SHOW COLUMNS FROM #__offlajn_users LIKE 'twitter_id'");
    if (!$db->loadRow()) {
      $db->setQuery("ALTER TABLE #__offlajn_users ADD twitter_id VARCHAR(255) NULL");
      $db->query();
    }
    $db->setQuery("SHOW TABLES LIKE '#__offlajn_oauths'");
    $res = $db->loadRow();
    if ($res) {
      $db->setQuery("SELECT id, app_id, app_secret, published FROM #__offlajn_oauths");
      $res = $db->loadObjectList('id');
      $db->setQuery("DROP TABLE #__offlajn_oauths");
      $db->query();
    }
    $db->setQuery("CREATE TABLE IF NOT EXISTS #__offlajn_oauths(
      `id` int(11) NOT NULL auto_increment,
      `name` varchar(127) NOT NULL,
      `alias` varchar(127) NOT NULL,
      `app_id` varchar(127) default NULL,
      `app_secret` varchar(127) default NULL,
      `published` tinyint(1) NOT NULL default '0',
      `create_app` varchar(255) NOT NULL,
      `auth` varchar(255) NOT NULL,
      `token` varchar(255) NOT NULL,
      `userinfo` varchar(255) NOT NULL,
      PRIMARY KEY  (`id`)
    )");
    $db->query();
    $db->setQuery("INSERT IGNORE INTO #__offlajn_oauths (`id`, `name`, `alias`, `create_app`, `auth`, `token`, `userinfo`) VALUES
      (1, 'Facebook', 'facebook', 'https://developers.facebook.com/apps', 'https://www.facebook.com/dialog/oauth?scope=email&response_type=code&display=popup', 'https://graph.facebook.com/oauth/access_token', 'https://graph.facebook.com/me'),
      (2, 'Google', 'google', 'https://code.google.com/apis/console/', 'https://accounts.google.com/o/oauth2/auth?scope=https%3A%2F%2Fwww.googleapis.com%2Fauth%2Fuserinfo.email+https%3A%2F%2Fwww.googleapis.com%2Fauth%2Fuserinfo.profile&response_type=code&display=popup', 'https://accounts.google.com/o/oauth2/token', 'https://www.googleapis.com/oauth2/v2/userinfo'),
      (3, 'Twitter', 'twitter', 'https://dev.twitter.com/apps', '', '', ''),
      (4, 'Microsoft', 'windows', 'https://manage.dev.live.com/Applications', 'https://login.live.com/oauth20_authorize.srf?scope=wl.emails&response_type=code&display=popup', 'https://login.live.com/oauth20_token.srf', 'https://apis.live.net/v5.0/me')");
    $db->query();
    if ($res) {
      foreach ($res as $id => $oauth) {
        $db->updateObject('#__offlajn_oauths', $oauth, 'id', false);
      }
    }
	}
	
	function uninstall() {
  }

}